// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * ESS reading profile
 * </pre>
 *
 * Protobuf type {@code essmodule.ESSReadingProfile}
 */
public final class ESSReadingProfile extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.ESSReadingProfile)
    ESSReadingProfileOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ESSReadingProfile.newBuilder() to construct.
  private ESSReadingProfile(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ESSReadingProfile() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ESSReadingProfile();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReadingProfile_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReadingProfile_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.ESSReadingProfile.class, openfmb.essmodule.ESSReadingProfile.Builder.class);
  }

  public static final int READINGMESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ReadingMessageInfo readingMessageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the readingMessageInfo field is set.
   */
  @java.lang.Override
  public boolean hasReadingMessageInfo() {
    return readingMessageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The readingMessageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMessageInfo getReadingMessageInfo() {
    return readingMessageInfo_ == null ? openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ReadingMessageInfoOrBuilder getReadingMessageInfoOrBuilder() {
    return readingMessageInfo_ == null ? openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
  }

  public static final int ESS_FIELD_NUMBER = 2;
  private openfmb.commonmodule.ESS ess_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the ess field is set.
   */
  @java.lang.Override
  public boolean hasEss() {
    return ess_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The ess.
   */
  @java.lang.Override
  public openfmb.commonmodule.ESS getEss() {
    return ess_ == null ? openfmb.commonmodule.ESS.getDefaultInstance() : ess_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ESSOrBuilder getEssOrBuilder() {
    return ess_ == null ? openfmb.commonmodule.ESS.getDefaultInstance() : ess_;
  }

  public static final int ESSREADING_FIELD_NUMBER = 3;
  private openfmb.essmodule.ESSReading essReading_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the essReading field is set.
   */
  @java.lang.Override
  public boolean hasEssReading() {
    return essReading_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The essReading.
   */
  @java.lang.Override
  public openfmb.essmodule.ESSReading getEssReading() {
    return essReading_ == null ? openfmb.essmodule.ESSReading.getDefaultInstance() : essReading_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.essmodule.ESSReadingOrBuilder getEssReadingOrBuilder() {
    return essReading_ == null ? openfmb.essmodule.ESSReading.getDefaultInstance() : essReading_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (readingMessageInfo_ != null) {
      output.writeMessage(1, getReadingMessageInfo());
    }
    if (ess_ != null) {
      output.writeMessage(2, getEss());
    }
    if (essReading_ != null) {
      output.writeMessage(3, getEssReading());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (readingMessageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getReadingMessageInfo());
    }
    if (ess_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getEss());
    }
    if (essReading_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getEssReading());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.ESSReadingProfile)) {
      return super.equals(obj);
    }
    openfmb.essmodule.ESSReadingProfile other = (openfmb.essmodule.ESSReadingProfile) obj;

    if (hasReadingMessageInfo() != other.hasReadingMessageInfo()) return false;
    if (hasReadingMessageInfo()) {
      if (!getReadingMessageInfo()
          .equals(other.getReadingMessageInfo())) return false;
    }
    if (hasEss() != other.hasEss()) return false;
    if (hasEss()) {
      if (!getEss()
          .equals(other.getEss())) return false;
    }
    if (hasEssReading() != other.hasEssReading()) return false;
    if (hasEssReading()) {
      if (!getEssReading()
          .equals(other.getEssReading())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasReadingMessageInfo()) {
      hash = (37 * hash) + READINGMESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getReadingMessageInfo().hashCode();
    }
    if (hasEss()) {
      hash = (37 * hash) + ESS_FIELD_NUMBER;
      hash = (53 * hash) + getEss().hashCode();
    }
    if (hasEssReading()) {
      hash = (37 * hash) + ESSREADING_FIELD_NUMBER;
      hash = (53 * hash) + getEssReading().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReadingProfile parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSReadingProfile parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSReadingProfile parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.ESSReadingProfile prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * ESS reading profile
   * </pre>
   *
   * Protobuf type {@code essmodule.ESSReadingProfile}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.ESSReadingProfile)
      openfmb.essmodule.ESSReadingProfileOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReadingProfile_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReadingProfile_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.ESSReadingProfile.class, openfmb.essmodule.ESSReadingProfile.Builder.class);
    }

    // Construct using openfmb.essmodule.ESSReadingProfile.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      readingMessageInfo_ = null;
      if (readingMessageInfoBuilder_ != null) {
        readingMessageInfoBuilder_.dispose();
        readingMessageInfoBuilder_ = null;
      }
      ess_ = null;
      if (essBuilder_ != null) {
        essBuilder_.dispose();
        essBuilder_ = null;
      }
      essReading_ = null;
      if (essReadingBuilder_ != null) {
        essReadingBuilder_.dispose();
        essReadingBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSReadingProfile_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSReadingProfile getDefaultInstanceForType() {
      return openfmb.essmodule.ESSReadingProfile.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.ESSReadingProfile build() {
      openfmb.essmodule.ESSReadingProfile result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSReadingProfile buildPartial() {
      openfmb.essmodule.ESSReadingProfile result = new openfmb.essmodule.ESSReadingProfile(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.ESSReadingProfile result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.readingMessageInfo_ = readingMessageInfoBuilder_ == null
            ? readingMessageInfo_
            : readingMessageInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.ess_ = essBuilder_ == null
            ? ess_
            : essBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.essReading_ = essReadingBuilder_ == null
            ? essReading_
            : essReadingBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.ESSReadingProfile) {
        return mergeFrom((openfmb.essmodule.ESSReadingProfile)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.ESSReadingProfile other) {
      if (other == openfmb.essmodule.ESSReadingProfile.getDefaultInstance()) return this;
      if (other.hasReadingMessageInfo()) {
        mergeReadingMessageInfo(other.getReadingMessageInfo());
      }
      if (other.hasEss()) {
        mergeEss(other.getEss());
      }
      if (other.hasEssReading()) {
        mergeEssReading(other.getEssReading());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getReadingMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getEssFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getEssReadingFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ReadingMessageInfo readingMessageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMessageInfo, openfmb.commonmodule.ReadingMessageInfo.Builder, openfmb.commonmodule.ReadingMessageInfoOrBuilder> readingMessageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the readingMessageInfo field is set.
     */
    public boolean hasReadingMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The readingMessageInfo.
     */
    public openfmb.commonmodule.ReadingMessageInfo getReadingMessageInfo() {
      if (readingMessageInfoBuilder_ == null) {
        return readingMessageInfo_ == null ? openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
      } else {
        return readingMessageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setReadingMessageInfo(openfmb.commonmodule.ReadingMessageInfo value) {
      if (readingMessageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        readingMessageInfo_ = value;
      } else {
        readingMessageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setReadingMessageInfo(
        openfmb.commonmodule.ReadingMessageInfo.Builder builderForValue) {
      if (readingMessageInfoBuilder_ == null) {
        readingMessageInfo_ = builderForValue.build();
      } else {
        readingMessageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeReadingMessageInfo(openfmb.commonmodule.ReadingMessageInfo value) {
      if (readingMessageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          readingMessageInfo_ != null &&
          readingMessageInfo_ != openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance()) {
          getReadingMessageInfoBuilder().mergeFrom(value);
        } else {
          readingMessageInfo_ = value;
        }
      } else {
        readingMessageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearReadingMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      readingMessageInfo_ = null;
      if (readingMessageInfoBuilder_ != null) {
        readingMessageInfoBuilder_.dispose();
        readingMessageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ReadingMessageInfo.Builder getReadingMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getReadingMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ReadingMessageInfoOrBuilder getReadingMessageInfoOrBuilder() {
      if (readingMessageInfoBuilder_ != null) {
        return readingMessageInfoBuilder_.getMessageOrBuilder();
      } else {
        return readingMessageInfo_ == null ?
            openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance() : readingMessageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ReadingMessageInfo readingMessageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ReadingMessageInfo, openfmb.commonmodule.ReadingMessageInfo.Builder, openfmb.commonmodule.ReadingMessageInfoOrBuilder> 
        getReadingMessageInfoFieldBuilder() {
      if (readingMessageInfoBuilder_ == null) {
        readingMessageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ReadingMessageInfo, openfmb.commonmodule.ReadingMessageInfo.Builder, openfmb.commonmodule.ReadingMessageInfoOrBuilder>(
                getReadingMessageInfo(),
                getParentForChildren(),
                isClean());
        readingMessageInfo_ = null;
      }
      return readingMessageInfoBuilder_;
    }

    private openfmb.commonmodule.ESS ess_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ESS, openfmb.commonmodule.ESS.Builder, openfmb.commonmodule.ESSOrBuilder> essBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the ess field is set.
     */
    public boolean hasEss() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The ess.
     */
    public openfmb.commonmodule.ESS getEss() {
      if (essBuilder_ == null) {
        return ess_ == null ? openfmb.commonmodule.ESS.getDefaultInstance() : ess_;
      } else {
        return essBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setEss(openfmb.commonmodule.ESS value) {
      if (essBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ess_ = value;
      } else {
        essBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setEss(
        openfmb.commonmodule.ESS.Builder builderForValue) {
      if (essBuilder_ == null) {
        ess_ = builderForValue.build();
      } else {
        essBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeEss(openfmb.commonmodule.ESS value) {
      if (essBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          ess_ != null &&
          ess_ != openfmb.commonmodule.ESS.getDefaultInstance()) {
          getEssBuilder().mergeFrom(value);
        } else {
          ess_ = value;
        }
      } else {
        essBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearEss() {
      bitField0_ = (bitField0_ & ~0x00000002);
      ess_ = null;
      if (essBuilder_ != null) {
        essBuilder_.dispose();
        essBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ESS.Builder getEssBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getEssFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ESSOrBuilder getEssOrBuilder() {
      if (essBuilder_ != null) {
        return essBuilder_.getMessageOrBuilder();
      } else {
        return ess_ == null ?
            openfmb.commonmodule.ESS.getDefaultInstance() : ess_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ESS ess = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ESS, openfmb.commonmodule.ESS.Builder, openfmb.commonmodule.ESSOrBuilder> 
        getEssFieldBuilder() {
      if (essBuilder_ == null) {
        essBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ESS, openfmb.commonmodule.ESS.Builder, openfmb.commonmodule.ESSOrBuilder>(
                getEss(),
                getParentForChildren(),
                isClean());
        ess_ = null;
      }
      return essBuilder_;
    }

    private openfmb.essmodule.ESSReading essReading_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSReading, openfmb.essmodule.ESSReading.Builder, openfmb.essmodule.ESSReadingOrBuilder> essReadingBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the essReading field is set.
     */
    public boolean hasEssReading() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The essReading.
     */
    public openfmb.essmodule.ESSReading getEssReading() {
      if (essReadingBuilder_ == null) {
        return essReading_ == null ? openfmb.essmodule.ESSReading.getDefaultInstance() : essReading_;
      } else {
        return essReadingBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setEssReading(openfmb.essmodule.ESSReading value) {
      if (essReadingBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        essReading_ = value;
      } else {
        essReadingBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setEssReading(
        openfmb.essmodule.ESSReading.Builder builderForValue) {
      if (essReadingBuilder_ == null) {
        essReading_ = builderForValue.build();
      } else {
        essReadingBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeEssReading(openfmb.essmodule.ESSReading value) {
      if (essReadingBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          essReading_ != null &&
          essReading_ != openfmb.essmodule.ESSReading.getDefaultInstance()) {
          getEssReadingBuilder().mergeFrom(value);
        } else {
          essReading_ = value;
        }
      } else {
        essReadingBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearEssReading() {
      bitField0_ = (bitField0_ & ~0x00000004);
      essReading_ = null;
      if (essReadingBuilder_ != null) {
        essReadingBuilder_.dispose();
        essReadingBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.essmodule.ESSReading.Builder getEssReadingBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getEssReadingFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.essmodule.ESSReadingOrBuilder getEssReadingOrBuilder() {
      if (essReadingBuilder_ != null) {
        return essReadingBuilder_.getMessageOrBuilder();
      } else {
        return essReading_ == null ?
            openfmb.essmodule.ESSReading.getDefaultInstance() : essReading_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.essmodule.ESSReading essReading = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSReading, openfmb.essmodule.ESSReading.Builder, openfmb.essmodule.ESSReadingOrBuilder> 
        getEssReadingFieldBuilder() {
      if (essReadingBuilder_ == null) {
        essReadingBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.essmodule.ESSReading, openfmb.essmodule.ESSReading.Builder, openfmb.essmodule.ESSReadingOrBuilder>(
                getEssReading(),
                getParentForChildren(),
                isClean());
        essReading_ = null;
      }
      return essReadingBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.ESSReadingProfile)
  }

  // @@protoc_insertion_point(class_scope:essmodule.ESSReadingProfile)
  private static final openfmb.essmodule.ESSReadingProfile DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.ESSReadingProfile();
  }

  public static openfmb.essmodule.ESSReadingProfile getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ESSReadingProfile>
      PARSER = new com.google.protobuf.AbstractParser<ESSReadingProfile>() {
    @java.lang.Override
    public ESSReadingProfile parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ESSReadingProfile> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ESSReadingProfile> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.ESSReadingProfile getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

